﻿package  {
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.net.*;
	import flash.ui.*;
	import flash.utils.*;
	
	public class Hitchhiker extends MovieClip {

		private var cirrus:String = "rtmfp://p2p.rtmfp.net";
		private var key:String = "a0c9041418ccd230b673bffb-8064600585a1";
		private var nc:NetConnection = new NetConnection();
		private var nearID:String, sendStream:NetStream, netStream:NetStream;
		private var lastWrite:int = 0, lastHitch:int = 0, newPlanet:String;
		private var waiting:Boolean = false;
		private var streams:Array = [];

		public function init():void {
			stop();
			nc.addEventListener(NetStatusEvent.NET_STATUS,netConnectionHandler);
			nc.connect(cirrus,key);
			
			tf.addEventListener(Event.CHANGE,
				function(e:Event):void {
					tf.text = tf.text.toUpperCase();
					lastWrite = getTimer();
					lastHitch=0;
				});
			tf.addEventListener(KeyboardEvent.KEY_DOWN,
				function(e:KeyboardEvent):void {
					if(e.keyCode==Keyboard.ENTER) {
						hitch.gotoAndStop("HITCH");
						lastHitch = getTimer();
					}
				});
				
			addEventListener(Event.ENTER_FRAME,updateState);
			

			hitch.visible = false;
			setTimeout(ship.gotoAndPlay,3000,"ARRIVE");
			
		}
		
		private function netConnectionHandler(e:NetStatusEvent):void {
			if(e.info.code=="NetConnection.Connect.Success") {
				nearID = (nc.nearID);
				trace(">>>",nearID);
				sendStream = new NetStream(nc, NetStream.DIRECT_CONNECTIONS);
				sendStream.publish("com");
			}
			else if(e.info.code=="NetStream.Connect.Success") {
				e.info.stream.client = {
					chat:chat
				};
				streams.push(e.info.stream);
				space.alien.visible = true;
			}
			else if(e.info.code=="NetStream.Connect.Close") {
				space.peered = false;
			}
		}

		private function chat(msg:String):void {
			space.dialog.text = msg;
		}
		
		public function cutStream():void {
			if(netStream) {
				netStream.close();
				netStream = null;
			}
			while(streams.length) {
				(streams.pop() as NetStream).close();
			}
		}

		public function updateState(e:Event):void {
			if(stage.focus!=tf) {
				stage.focus = tf;
			}
			var now:int = getTimer();
			
			if(ship.currentLabel=="OUT" && !hitch.visible) {
				if(!waiting) {
					space.peered = false;
					cutStream();
					ship.stop();
					waiting = true;
					if(nearID && nearID.length && !Stories.STORY[newPlanet]) {
						var url:String = "http://vincent.netau.net/planet.php?planet="+newPlanet+"&uid="+nearID;
						var loader:URLLoader = new URLLoader();
						loader.addEventListener(Event.COMPLETE,
							function(e:Event):void {
								var peer:String = loader.data;
								if(peer && peer.length) {
									netStream = new NetStream(nc,peer);
									netStream.client = {
										chat:chat
									};
									
									netStream.addEventListener(NetStatusEvent.NET_STATUS,
										function(e:NetStatusEvent):void {
											trace(e.info.code);
											if(e.info.code=="NetStream.Play.Start") {
												space.alien.visible = true;
												space.peered = true;
											}
										});
									netStream.play("com");

								}
								waiting = false;
								ship.play();
							});
						loader.load(new URLRequest(url));
					}
					else {
						waiting = false;
						ship.play();
					}
				}
				else {
					
				}
			}
			else if(ship.currentLabel=="HITCH") {
				hitch.visible = !hitch.visible;
			}
			else if(ship.currentLabel=="HITCHOUT" && space.alien.body.eyes.currentLabel!="HELLO") {
				space.alien.body.eyes.gotoAndStop("HELLO");
				space.alien.body.blink.gotoAndPlay(2);
			}
			else if(ship.currentLabel=="ANOTHERPLANET") {
				if(!hitch.visible) {
					ship.gotoAndPlay("ARRIVE");
					space.planet = newPlanet;
					newPlanet = null;
					lastHitch = 0;
					lastWrite = 0;
					tf.text = "";
				}
				else {
					ship.gotoAndStop("STANDBY");
				}
			}
			else if(ship.currentLabel=="STANDBY" && hitch.currentLabel=="HITCH" && now-lastHitch>10000) {
				newPlanet = tf.text;
				ship.play();
			}
			if(lastHitch) {
				hitch.gotoAndStop("HITCH");
			}
			else if(lastWrite && now-lastWrite<500) {
				hitch.gotoAndStop("WRITE");
				lastHitch = 0;
			}
//			else if(lastWrite && now-lastWrite>5000 && tf.text.length) {
//				hitch.gotoAndStop("HITCH");
//				lastHitch = getTimer();
//			}
			else {
				if(hitch.currentLabel=="WRITE") {
					send("chat",tf.text);
				}
				hitch.gotoAndStop(tf.text.length?"SIGN":"PONDER");
			}
			if(hitch.tf) {
				hitch.tf.text = tf.text;
			}
			hitchy.visible = hitch.visible && hitch.currentLabel=="SIGN";
		}
		
		public function send(command:String,...params):void {
			if(sendStream)
				sendStream.send.apply(null,[command].concat(params));
			if(netStream)
				netStream.send.apply(null,[command].concat(params));
		}
	}
	
}
