﻿package  {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.ui.*;
	import flash.utils.*;
	import com.newgrounds.*;
	import com.newgrounds.components.*;
	import com.newgrounds.encoders.json.*;
	
	public class Hitchhiker extends MovieClip {

		static public const version:String = "1.0";

		private var cirrus:String = "rtmfp://p2p.rtmfp.net";
		private var key:String = "a0c9041418ccd230b673bffb-8064600585a1";
		private var nc:NetConnection = new NetConnection();
		private var nearID:String, sendStream:NetStream, netStream:NetStream;
		private var lastWrite:int = 0, lastHitch:int = 0, newPlanet:String;
		private var waiting:Boolean = false;
		private var streams:Array = [];
		public var files:Object = {};
		private var targetPlanet:String = "ABUBA";
		private var apiInited:Boolean;

		function Hitchhiker():void {
			opaqueBackground = 0x000033;
//			addEventListener(Event.ENTER_FRAME,updateState);
			addEventListener("visitPlanet",onVisit);
		}
		
		private function onVisit(e:CustomEvent):void {
			visitPlanet(e.data.planet);
		}
		
		public function visitPlanet(planet:String):void {
			targetPlanet = planet
			
			if(files[planet] && !files[planet].data) {
				files[planet].load();
			}
			else if(currentLabel!="GAME") {
				MovieClip(root).gotoAndStop("GAME","Planet");
				cover.visible = true;
			}
			else {
				if(!Stories.STORY[planet] && !files[planet]) {
					queryPlanet(planet);
				}
				else {
					arriveOnPlanet(planet);
				}
			}
		}
		
		public function queryPlanetById(id:String):void {
			var query:SaveQuery = API.createSaveQuery("Planets");
			if(query) {
				query.page = 1;
				query.addCondition(SaveQuery.FILE_ID, SaveQuery.OPERATOR_EQUAL, id);
				query.resultsPerPage = 1;
				query.addEventListener(APIEvent.QUERY_COMPLETE, 
					function(e:APIEvent):void {
						e.currentTarget.removeEventListener(e.type,arguments.callee);
						var saveFile:SaveFile = query.files[0];
						if(saveFile) {
							files[saveFile.name] = saveFile;
							visitPlanet(saveFile.name);
						}
						else {
							if(ad) {
								ad.visible = true;
							}
						}
					});
				query.execute();
			}
		}
		
		private function queryPlanet(planet:String):void {
			var query:SaveQuery = API.createSaveQuery("Planets");
			query.sortOn(SaveQuery.UPDATED_ON,true);
			if(query) {
				query.page = 1;
				query.addCondition(SaveQuery.FILE_NAME, SaveQuery.OPERATOR_EQUAL, planet);
				query.resultsPerPage = 1;
				query.addEventListener(APIEvent.QUERY_COMPLETE, 
					function(e:APIEvent):void {
						e.currentTarget.removeEventListener(e.type,arguments.callee);
						var saveFile:SaveFile = query.files[0];
						if(saveFile) {
							files[saveFile.name] = saveFile;
							visitPlanet(planet);
						}
						else {
							arriveOnPlanet(planet);
						}
					});
				query.execute();
			}
		}
		
		private function arriveOnPlanet(planet:String):void {
			if(ship.currentLabel!="ARRIVE")
				ship.gotoAndPlay("ARRIVE");
			planetName = planet;
			newPlanet = null;
			lastHitch = 0;
			lastWrite = 0;
			tf.text = "";
		}
		
		public function init():void {
			stop();
			addEventListener(Event.ENTER_FRAME,onReady);
		}
		
		private function onReady(e:Event):void {
			removeEventListener(Event.ENTER_FRAME,onReady);
//			nc.addEventListener(NetStatusEvent.NET_STATUS,netConnectionHandler);
//			nc.connect(cirrus,key);
//			trace(tf,hitch,space,space.vacantsign,tenant);
			addEventListener(Event.ENTER_FRAME,updateState);

			tf.addEventListener(Event.CHANGE,
				function(e:Event):void {
					tf.text = tf.text.toUpperCase();
					lastWrite = getTimer();
					lastHitch=0;
				});
			tf.addEventListener(KeyboardEvent.KEY_DOWN,
				function(e:KeyboardEvent):void {
					if(e.keyCode==Keyboard.ENTER) {
						hitch.gotoAndStop("HITCH");
						lastHitch = getTimer();
					}
				});
				
			hitch.visible = false;
			setTimeout(ship.gotoAndPlay,3000,"ARRIVE");
			
			var back = getChildByName("back") as SimpleButton;
			back.addEventListener(MouseEvent.CLICK,onBack);
			back.visible = false;
			
			tenant.visible = false;
			space.vacantsign.buttonMode = true;
			space.vacantsign.addEventListener(MouseEvent.CLICK,onVacant);
			
			tenant.addEventListener(Event.COMPLETE,applicationComplete);
			
			planetName = targetPlanet;
			cover.visible = false;			
		}
		
		public function initAPI():void {
			apiInited = true;
			API.addEventListener(APIEvent.FILE_LOADED,onFileLoaded);
			API.addEventListener(APIEvent.FILE_SAVED,onFileSaved);
		}
		
		public function queryStart(page:int):void {
			if(nextPage)
				nextPage.visible = false;
			var query:SaveQuery = API.createSaveQuery("Planets");
			query.sortOn(SaveQuery.UPDATED_ON,true);
			if(query) {
				query.page = page;
	//			if(id) {
	//				query.addCondition(SaveQuery.FILE_ID, SaveQuery.OPERATOR_EQUAL, id);
	//			}
				// a maximum of 100 files can be returned in one query, to get the rest you have to change the page
				query.resultsPerPage = 12;
				query.addEventListener(APIEvent.QUERY_COMPLETE, onQuery);
				query.execute();
			}
		} 
			
		
		public function set planetName(value:String):void {
			space.planet = value;
			tenant.planet = value;
		}
		
		public function get planetName():String {
			return space.planet;
		}
		
		public function set alienFrame(value:int):void {
			tenant.alienFrame = value;
		}
		
		private function onVacant(e:MouseEvent):void {
			tenant.visible = true;
			stage.focus = tenant.monologue;
		}
		
		private function onQuery(e:APIEvent):void {
			var query:SaveQuery = e.data as SaveQuery;
			var planetNames:Array = [];
			var count:int = 0;
			for each(var saveFile:SaveFile in query.files) {
				trace(JSON.stringify(saveFile));
				if(saveFile.description!="deleted") {
					planetNames.push(saveFile.name);
					files[saveFile.name] = saveFile;
				}
				count++;
			}
			var planetaArray:Array = [];
			for(var i:int=0;i<planetas.numChildren;i++) {
				var child:Planeta = planetas.getChildAt(i) as Planeta;
				if(child) {
					planetaArray.push(child);
				}
			}
			planetaArray.sortOn("y",Array.NUMERIC);
			if(nextPage)
				nextPage.visible = count>=12;

			for(i=0;i<planetaArray.length;i++) {
				if(i<planetNames.length) {
					planetaArray[i].planet = planetNames[i];
					planetaArray[i].visible = true;
					saveFile = files[planetNames[i]];
					saveFile.attachIcon(planetaArray[i].icon);
					planetaArray[i].tf.text = saveFile.name + " (" + saveFile.authorName + "): "+saveFile.views+" visits.";
				}
				else {
					planetaArray[i].visible = false;
				}
			}
//			planets_tf.text = planetNames.join("\n");
		}
		
		private function onBack(e:MouseEvent):void {
			gotoAndStop("INTRO","IntroScreen");
		}
		
		private function netConnectionHandler(e:NetStatusEvent):void {
			if(e.info.code=="NetConnection.Connect.Success") {
				nearID = (nc.nearID);
				trace(">>>",nearID);
				sendStream = new NetStream(nc, NetStream.DIRECT_CONNECTIONS);
				sendStream.publish("com");
			}
			else if(e.info.code=="NetStream.Connect.Success") {
				e.info.stream.client = {
					chat:chat
				};
				streams.push(e.info.stream);
				space.alien.visible = true;
			}
			else if(e.info.code=="NetStream.Connect.Close") {
				space.peered = false;
			}
		}

		private function chat(msg:String):void {
			space.dialog.text = msg;
		}
		
		public function cutStream():void {
			if(netStream) {
				netStream.close();
				netStream = null;
			}
			while(streams.length) {
				(streams.pop() as NetStream).close();
			}
		}

		public function updateState(e:Event):void {
			if(currentScene.name!="Planet") {
				return;
			}
			
			if(stage.focus!=tf && !tenant.visible) {
				stage.focus = tf;
			}
			var now:int = getTimer();
			
			back.visible = hitch.visible;
			
			if(ship.currentLabel=="OUT" && !hitch.visible) {
				if(!waiting) {
					space.peered = false;
					cutStream();
					ship.stop();
					waiting = true;
					if(nearID && nearID.length && !Stories.STORY[newPlanet]) {
						var url:String = "http://vincent.netau.net/planet.php?planet="+newPlanet+"&uid="+nearID;
						var loader:URLLoader = new URLLoader();
						loader.addEventListener(Event.COMPLETE,
							function(e:Event):void {
								var peer:String = loader.data;
								if(peer && peer.length) {
									netStream = new NetStream(nc,peer);
									netStream.client = {
										chat:chat
									};
									
									netStream.addEventListener(NetStatusEvent.NET_STATUS,
										function(e:NetStatusEvent):void {
											trace(e.info.code);
											if(e.info.code=="NetStream.Play.Start") {
												space.alien.visible = true;
												space.peered = true;
											}
										});
									netStream.play("com");

								}
								waiting = false;
								ship.play();
							});
						loader.load(new URLRequest(url));
					}
					else {
						waiting = false;
						ship.play();
					}
				}
				else {
					
				}
			}
			else if(ship.currentLabel=="HITCH") {
				hitch.visible = !hitch.visible;
			}
			else if(ship.currentLabel=="HITCHOUT" && space.alien.body.eyes.currentLabel!="HELLO") {
				space.alien.body.eyes.gotoAndStop("HELLO");
				space.alien.body.blink.gotoAndPlay(2);
			}
			else if(ship.currentLabel=="ANOTHERPLANET") {
				if(!hitch.visible) {
					if(Stories.STORY[newPlanet]) {
						arriveOnPlanet(newPlanet);
					}
					else if(targetPlanet!=newPlanet) {
						visitPlanet(newPlanet);						
					}
				}
				else {
					ship.gotoAndStop("STANDBY");
				}
			}
			else if(ship.currentLabel=="STANDBY" && hitch.currentLabel=="HITCH" && now-lastHitch>5000) {
				newPlanet = tf.text;
				ship.play();
			}
			if(lastHitch) {
				hitch.gotoAndStop("HITCH");
			}
			else if(lastWrite && now-lastWrite<500) {
				hitch.gotoAndStop("WRITE");
				lastHitch = 0;
			}
//			else if(lastWrite && now-lastWrite>5000 && tf.text.length) {
//				hitch.gotoAndStop("HITCH");
//				lastHitch = getTimer();
//			}
			else {
				if(hitch.currentLabel=="WRITE") {
					send("chat",tf.text);
				}
				hitch.gotoAndStop(tf.text.length?"SIGN":"PONDER");
			}
			if(hitch.tf) {
				hitch.tf.text = tf.text;
			}
			hitchy.visible = hitch.visible && hitch.currentLabel=="SIGN";
		}
		
		public function send(command:String,...params):void {
			if(sendStream)
				sendStream.send.apply(null,[command].concat(params));
			if(netStream)
				netStream.send.apply(null,[command].concat(params));
		}
		
		private function applicationComplete(e:Event):void {
			var saveFile:SaveFile = files[planetName] && (files[planetName]!="deleted" || !files[planetName].readOnly)? files[planetName] : API.createSaveFile("Planets");
			saveFile.name = planetName;
			saveFile.description = "Planet";
			saveFile.createIcon(tenant.bitmapData);
			saveFile.data = {planetInfo:{0:tenant.text.split("\r").join("\n").split("\n")}, restoreMap:tenant.photo.restoreMap};
			saveFile.save();
		}
		
		private function updateAlien(saveFile:SaveFile):void {
			files[saveFile.name] = saveFile;
			if(saveFile.name==planetName) {
				planetName = planetName;	//	update planet
			}
		}
		
		private function onFileLoaded(e:APIEvent):void {
			var saveFile:SaveFile = e.data as SaveFile;
			if(targetPlanet == saveFile.name) {
				visitPlanet(targetPlanet);
			}
		}
		
		private function onFileSaved(e:APIEvent):void {
			var saveFile:SaveFile = e.data as SaveFile;
			updateAlien(saveFile);
		}
	}
	
}
