﻿package  {
	import flash.display.*;
	public class ImageUtil {

		static public function flatten(bitmapData:BitmapData):Object {
			var pixels:Vector.<uint> = bitmapData.getVector(bitmapData.rect);
			var colors:Object = {};
			var restoreMap:Object = {};
			var transparentPixels:Vector.<uint> = new <uint>[0];
			//	calculate tranparent pixels
			for (var i:int=0;i<pixels.length;i++) {
				var pixel:uint = pixels[i];
				if(pixel && !colors[pixel]) {
					colors[pixel] = pixel;
					if(uint(pixel&0xFF000000)!=0xFF000000) {
						transparentPixels.push(pixel);
					}
				}
			}
			
			//	calculate replacement map
			if(transparentPixels.length) {
				for(pixel=0xFF000000;pixel<0xFFFFFFFF;pixel++) {
					if(!colors[pixel]) {
						var tPixel:uint = transparentPixels.pop();
						colors[tPixel] = pixel;
						restoreMap[pixel] = tPixel;
						if(!transparentPixels.length) {
							break;
						}
					}
				}
			}
			
			//	replace pixels
			for(i=0;i<pixels.length;i++) {
				pixel = pixels[i];
				var tNew:uint = colors[pixel];
				if(tNew) {
					pixels[i] = tNew;
				}
			}
			bitmapData.setVector(bitmapData.rect,pixels);
			return restoreMap;
		}
		
		static public function unflatten(bitmapData:BitmapData,restoreMap:Object):void {
			var pixels:Vector.<uint> = bitmapData.getVector(bitmapData.rect);
			for(var i:int=0;i<pixels.length;i++) {
				var pixel:uint = pixels[i];
				if(restoreMap.hasOwnProperty(pixel)) {
					var newPixel:uint = restoreMap[pixel];
					pixels[i] = newPixel;
				}
			}
			bitmapData.setVector(bitmapData.rect,pixels);
		}
	}
	
}
