﻿package  {
	
	import flash.display.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.net.*;
	import flash.geom.*;
	import by.blooddy.crypto.image.PNGEncoder;
	
	public class ProfileLoader extends MovieClip {

		private var file:FileReference = new FileReference();
		private var downfile:FileReference = new FileReference();
		private var imageLoader:Loader = new Loader();
		private var bmp:Bitmap = new Bitmap(new BitmapData(90,90,true,0));
		public var restoreMap:Object;
		
		public function ProfileLoader() {
			file.addEventListener(Event.SELECT,onSelect);
			file.addEventListener(Event.COMPLETE,onLoaded);
			upload.addEventListener(MouseEvent.CLICK,onUpload);
			download.addEventListener(MouseEvent.CLICK,onDownload);
			cancel.addEventListener(MouseEvent.CLICK,onCancel);
			defaultButton.addEventListener(MouseEvent.CLICK,onDefault);
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE,onLoadedImage);
			loada.addChild(bmp);
			loada.framer.body.eyes.gotoAndStop("HELLO");
		}
		
		public function reset():void {
			onDefault(null);
		}
		
		public function set alienFrame(value:int):void {
			loada.framer.gotoAndStop(value);
		}
		
		private function onDefault(e:MouseEvent):void {
			bitmapData.fillRect(bitmapData.rect,0);
			bitmapData.draw(loada.framer);
			restoreMap = ImageUtil.flatten(bitmapData);
			loada.framer.visible = true;
			visible = false;
			dispatchEvent(new Event(Event.CHANGE));
		}
		
		private function onDownload(e:MouseEvent):void {
			var bytes:ByteArray = new ByteArray();
			bytes = PNGEncoder.encode(bitmapData);
			downfile.save(bytes,"alien.png");
		}
		
		private function onCancel(e:MouseEvent):void {
			visible = false;
		}
		
		private function onUpload(e:MouseEvent):void {
			file.browse([new FileFilter("Image","*.png;*jpeg;*.jpg","Image")]);
		}
		
		private function onSelect(e:Event):void {
			file.load();
		}
		
		public function get bitmapData():BitmapData {
			return bmp.bitmapData;
		}
		
		private function onLoaded(e:Event):void {
			imageLoader.loadBytes(file.data);
		}
		
		private function onLoadedImage(e:Event):void {
			var loadedBMP:Bitmap = imageLoader.content as Bitmap;
			if(loadedBMP) {
				loada.framer.visible = false;
				bitmapData.fillRect(bitmapData.rect,0);
				var scale:Number = Math.min(1,90/Math.max(loadedBMP.width,loadedBMP.height));
				bitmapData.draw(loadedBMP,new Matrix(scale,0,0,scale));
				restoreMap = ImageUtil.flatten(bitmapData);
				imageLoader.unload();
				visible = false;
				dispatchEvent(new Event(Event.CHANGE));
			}
		}
	}
	
}
